/////////////////////////////////////////////////////////////////////
// Simple speech interface for Glk
/////////////////////////////////////////////////////////////////////

#ifndef GLKTALK_H_
#define GLKTALK_H_

#pragma warning(disable : 4201)
#include <mmsystem.h>
#include <spchwrap.h>
#pragma warning(default : 4201)

class TextToSpeech
{
public:
	static TextToSpeech& GetSpeechEngine(void);

protected:
	static TextToSpeech SpeechEngine;

public:
	~TextToSpeech();

	struct ModeInfo
	{
		GUID Mode;
		CString Name;
	};
	typedef CArray<ModeInfo,ModeInfo&> ModeInfoArray;

	bool IsAvailable(void);
	const ModeInfoArray& GetModes(void);
	
	void Initialize(GUID& Voice, LPUNKNOWN pIDirectSound);
	void Destroy(void);

	void Speak(LPCSTR speech);

protected:
	TextToSpeech();

	int m_iAvailable;
	bool m_bInitialized;
	ModeInfoArray m_Modes;
	PCTTSMode m_pCTTSMode;
};

#endif // GLKTALK_H_
